力扣每日一题:使数组和能被p整除

给你一个正整数数组 nums,请你移除 最短 子数组(可以为 空 ),使得剩余元素的 和 能被 p 整除。 不允许 将整个数组都移除。

请你返回你需要移除的最短子数组的长度,如果无法满足题目要求,返回 -1 。

子数组 定义为原数组中连续的一组元素。

思路:

首先,这个题是要去掉某个子数组,因此要考虑用到前缀和的思想。

其次,这里是尝试去掉一部分后,剩下的部分余p等于0,也就是说,剩下的部分,和去掉的部分,余数是相同的。

那么,我们假设数组的和余p为x,要去除的区间是l,r,则有x=(sumr-suml)%p,而我们在遍历数组时,可以通过一次O(N)的时间复杂度得到x,后续遍历过程中,O(1)的时间复杂度得到sumr,那么,如果我们可以快速定位suml,就可以很快的找到符合条件的子数组。那么,如何快速找到这个suml,我们可以发现,这里要的是最短子数组,那么,suml一定是所有能符合x=(sumr-suml)%p中,最大的那个l。因此我们可以每次记录当前的前缀和余p,去更新对应位置。然后,每次只需要快速查找是否有符合条件的那个l,有就更新最小数组长度。

然后,我们来说一下这里的suml,suml就是((sumr-x)%p+p)%p,这里是确保一定出来的是一个正数。

要注意的是,这里如果用数组记录前缀和余p,会出现内存爆了的情况。

复制代码
class Solution {
public:
    int minSubarray(vector<int>& nums, int p) {
        int n = nums.size();
        vector<int> sum(n + 1, 0);
        for (int i = 0; i < n; i++)
            sum[i + 1] = (sum[i] + nums[i])%p;

        int x = sum[n] % p; // 表示两个区间模k余mm  (b-a)mod p=mm   bmodp -amodp==mm
        if (x == 0)
            return 0;

        for (int i = 0; i < n; i++) {
            if (nums[i] % p == x)
                return 1;
        }

        unordered_map<int,int> mxlen;// 记录当前模p余i的最大坐标
        int ans = n;
        for (int i = 0; i <= n; i++) {
           mxlen[sum[i]]=i;
           auto it=mxlen.find( ((sum[i]-x)%p+p)%p  );
           if(it!=mxlen.end())
           ans=min(ans,i-it->second);
        }
        if (ans==n)
            return -1;
        return ans;
    }
};
相关推荐
inrichtt15 分钟前
第八课时:SPI总线揭秘:四线全双工通信的奥
c语言·数据结构·stm32·单片机·嵌入式硬件
HPtiger1 小时前
数据结构——选择排序
数据结构·算法·排序算法
康实训1 小时前
老年评估仿真实训平台架构设计与老年人能力评估实训室教学落地实践
大数据·人工智能·算法·实训室·实训室建设
DongQiShanRen1 小时前
六根硬件映射(四):归属澄清、两处不一致与卷十一总表
开发语言·人工智能·算法·rust·哈希算法·集成学习
CCblandy1 小时前
雪花 ID 四个边界实测:时钟回拨重号 500 个,前端 JSON.parse 直接丢精度
后端·python·算法·性能优化·架构
丑梨数据2 小时前
信创环境里跑文档工具:格式兼容与本地合规的几个坑
数据结构·人工智能·算法·决策树·排序算法
烂蜻蜓2 小时前
Pandas入门教程(四):Series数据结构——创建、索引与常用方法
数据结构·pandas
erzong2313 小时前
Linux操作系统:线程概念与控制
linux·算法
Nil2084 小时前
leetcode 5最长回文子串
算法·leetcode·职场和发展
xxwl5854 小时前
区域赛分类题解
c++·笔记·学习·算法